
package ejb;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;


@Stateless
public class NewsEntityFacade implements NewsEntityFacadeLocal {
    @PersistenceContext
    private EntityManager em;

    public void create(NewsEntity newsEntity) {
        em.persist(newsEntity);
    }

    public void edit(NewsEntity newsEntity) {
        em.merge(newsEntity);
    }

    public void remove(NewsEntity newsEntity) {
        em.remove(em.merge(newsEntity));
            }

    public NewsEntity find(Object id) {
        return em.find(ejb.NewsEntity.class, id);
    }

    public List findAll() {
        return em.createQuery("select object(o) from NewsEntity as o").getResultList();
    }

}
